/*
 * THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT. 
 */

#include "varnish_mib.h"

static struct VSM_data *vd;

void
varnish_snmp_init(void)
{
    vd = VSM_New();
}

void
varnish_snmp_deinit(void)
{
    VSM_Close(vd);
}

struct VSM_data *
varnish_get_vsm_data()
{
    if (VSM_Abandoned(vd)) {
        DEBUGMSGTL(("varnish_mib", "reopening vd\n"));
        VSM_Close(vd);
        VSM_Open(vd);
    }
    return vd;
}

/*
 * Variable handlers.
 * 
 * An instance handler only hands us one request at a time, unwrapping
 * any eventual GETNEXT requests.  
 */

#if HAVE_STRUCT_VSC_C_MAIN_SESS_CONN
static int
handle_clientAcceptedConnections(netsnmp_mib_handler *handler,
                                 netsnmp_handler_registration *reginfo,
                                 netsnmp_agent_request_info *reqinfo,
                                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_conn >> 32;
            ctr.low = st->sess_conn & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientAcceptedConnections\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ
static int
handle_clientRequestsReceived(netsnmp_mib_handler *handler,
                              netsnmp_handler_registration *reginfo,
                              netsnmp_agent_request_info *reqinfo,
                              netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->client_req >> 32;
            ctr.low = st->client_req & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientRequestsReceived\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CACHE_HIT
static int
handle_clientCacheHits(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->cache_hit >> 32;
            ctr.low = st->cache_hit & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_clientCacheHits\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CACHE_HITPASS
static int
handle_clientCacheHitsPass(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->cache_hitpass >> 32;
            ctr.low = st->cache_hitpass & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientCacheHitsPass\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CACHE_MISS
static int
handle_clientCacheMisses(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->cache_miss >> 32;
            ctr.low = st->cache_miss & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientCacheMisses\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif

static int
handle_clientBan(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{
    int             ret;

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const char     *s = "";
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                     s, strlen(s));
        }
        break;

        /*
         * SET REQUEST
         *
         * multiple states in the transaction.  See:
         * http://www.net-snmp.org/tutorial-5/toolkit/mib_module/set-actions.jpg
         */
    case MODE_SET_RESERVE1:
        /*
         * or you could use netsnmp_check_vb_type_and_size instead 
         */
        ret = netsnmp_check_vb_type(requests->requestvb, ASN_OCTET_STR);
        if (ret != SNMP_ERR_NOERROR)
            netsnmp_set_request_error(reqinfo, requests, ret);
        break;

    case MODE_SET_RESERVE2:
        break;

    case MODE_SET_FREE:
        break;

    case MODE_SET_ACTION:
        ret = varnish_ban(reqinfo, requests, vd);
        if (ret != SNMP_ERR_NOERROR)
            netsnmp_set_request_error(reqinfo, requests, ret);
        break;

    case MODE_SET_COMMIT:
        break;

    case MODE_SET_UNDO:
        break;

    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_clientBan\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_400
static int
handle_clientRequests400(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->client_req_400 >> 32;
            ctr.low = st->client_req_400 & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientRequests400\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_411
static int
handle_clientRequests411(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->client_req_411 >> 32;
            ctr.low = st->client_req_411 & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientRequests411\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_413
static int
handle_clientRequests413(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->client_req_413 >> 32;
            ctr.low = st->client_req_413 & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientRequests413\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_417
static int
handle_clientRequests417(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->client_req_417 >> 32;
            ctr.low = st->client_req_417 & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientRequests417\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_CONN
static int
handle_backendConnSuccess(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->backend_conn >> 32;
            ctr.low = st->backend_conn & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnSuccess\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_UNHEALTHY
static int
handle_backendConnNotAttempted(netsnmp_mib_handler *handler,
                               netsnmp_handler_registration *reginfo,
                               netsnmp_agent_request_info *reqinfo,
                               netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->backend_unhealthy >> 32;
            ctr.low = st->backend_unhealthy & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnNotAttempted\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_BUSY
static int
handle_backendConnToMany(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->backend_busy >> 32;
            ctr.low = st->backend_busy & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnToMany\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_FAIL
static int
handle_backendConnFailures(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->backend_fail >> 32;
            ctr.low = st->backend_fail & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnFailures\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_REUSE
static int
handle_backendConnReuses(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->backend_reuse >> 32;
            ctr.low = st->backend_reuse & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnReuses\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_RECYCLE
static int
handle_backendConnRecycled(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->backend_recycle >> 32;
            ctr.low = st->backend_recycle & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnRecycled\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_TOOLATE
static int
handle_backendConnUnused(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->backend_toolate >> 32;
            ctr.low = st->backend_toolate & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnUnused\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_RETRY
static int
handle_backendConnRetry(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->backend_retry >> 32;
            ctr.low = st->backend_retry & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_backendConnRetry\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_REQ
static int
handle_backendRequests(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->backend_req >> 32;
            ctr.low = st->backend_req & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_backendRequests\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_SESS
static int
handle_totalSessions(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_sess >> 32;
            ctr.low = st->s_sess & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalSessions\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_REQ
static int
handle_totalRequests(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_req >> 32;
            ctr.low = st->s_req & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalRequests\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE
static int
handle_totalPipe(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_pipe >> 32;
            ctr.low = st->s_pipe & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalPipe\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PASS
static int
handle_totalPass(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_pass >> 32;
            ctr.low = st->s_pass & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalPass\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_FETCH
static int
handle_totalFetch(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_fetch >> 32;
            ctr.low = st->s_fetch & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalFetch\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_REQ_HDRBYTES
static int
handle_totalRequestHeaderBytes(netsnmp_mib_handler *handler,
                               netsnmp_handler_registration *reginfo,
                               netsnmp_agent_request_info *reqinfo,
                               netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_req_hdrbytes >> 32;
            ctr.low = st->s_req_hdrbytes & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalRequestHeaderBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_REQ_BODYBYTES
static int
handle_totalRequestBodyBytes(netsnmp_mib_handler *handler,
                             netsnmp_handler_registration *reginfo,
                             netsnmp_agent_request_info *reqinfo,
                             netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_req_bodybytes >> 32;
            ctr.low = st->s_req_bodybytes & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalRequestBodyBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_RESP_HDRBYTES
static int
handle_totalResponseHeaderBytes(netsnmp_mib_handler *handler,
                                netsnmp_handler_registration *reginfo,
                                netsnmp_agent_request_info *reqinfo,
                                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_resp_hdrbytes >> 32;
            ctr.low = st->s_resp_hdrbytes & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalResponseHeaderBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_RESP_BODYBYTES
static int
handle_totalResponseBodyBytes(netsnmp_mib_handler *handler,
                              netsnmp_handler_registration *reginfo,
                              netsnmp_agent_request_info *reqinfo,
                              netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_resp_bodybytes >> 32;
            ctr.low = st->s_resp_bodybytes & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalResponseBodyBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE_HDRBYTES
static int
handle_totalPipeHeaderBytes(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_pipe_hdrbytes >> 32;
            ctr.low = st->s_pipe_hdrbytes & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalPipeHeaderBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE_IN
static int
handle_totalPipeIn(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_pipe_in >> 32;
            ctr.low = st->s_pipe_in & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalPipeIn\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE_OUT
static int
handle_totalPipeOut(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->s_pipe_out >> 32;
            ctr.low = st->s_pipe_out & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalPipeOut\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_UPTIME
static int
handle_uptime(netsnmp_mib_handler *handler,
              netsnmp_handler_registration *reginfo,
              netsnmp_agent_request_info *reqinfo,
              netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            else {
                uint64_t        val = st->uptime * 100;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_TIMETICKS, &val, sizeof(val));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_uptime\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_CONN
static int
handle_sessAccepted(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_conn >> 32;
            ctr.low = st->sess_conn & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessAccepted\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_QUEUED
static int
handle_sessQueued(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_queued >> 32;
            ctr.low = st->sess_queued & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessQueued\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_DROPPED
static int
handle_sessDropped(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_dropped >> 32;
            ctr.low = st->sess_dropped & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessDropped\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_CLOSED
static int
handle_sessClosed(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_closed >> 32;
            ctr.low = st->sess_closed & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessClosed\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_PIPELINE
static int
handle_sessPipeline(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_pipeline >> 32;
            ctr.low = st->sess_pipeline & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessPipeline\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_READAHEAD
static int
handle_sessReadAhead(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_readahead >> 32;
            ctr.low = st->sess_readahead & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessReadAhead\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_HERD
static int
handle_sessHerd(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_herd >> 32;
            ctr.low = st->sess_herd & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessHerd\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_DROP
static int
handle_sessDrop(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_drop >> 32;
            ctr.low = st->sess_drop & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessDrop\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_FAIL
static int
handle_sessFail(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_fail >> 32;
            ctr.low = st->sess_fail & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessFail\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_PIPE_OVERFLOW
static int
handle_sessPipeOverflow(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->sess_pipe_overflow >> 32;
            ctr.low = st->sess_pipe_overflow & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessPipeOverflow\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_POOLS
static int
handle_threadsPools(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->pools >> 32;
            ctr.low = st->pools & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsPools\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS
static int
handle_threadsTotal(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->threads >> 32;
            ctr.low = st->threads & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsTotal\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_LIMITED
static int
handle_threadsLimitHits(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->threads_limited >> 32;
            ctr.low = st->threads_limited & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsLimitHits\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_CREATED
static int
handle_threadsCreated(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->threads_created >> 32;
            ctr.low = st->threads_created & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsCreated\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_DESTROYED
static int
handle_threadsDestroyed(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->threads_destroyed >> 32;
            ctr.low = st->threads_destroyed & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsDestroyed\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_FAILED
static int
handle_threadsFailed(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->threads_failed >> 32;
            ctr.low = st->threads_failed & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsFailed\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREAD_QUEUE_LEN
static int
handle_threadsQueueLength(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->thread_queue_len >> 32;
            ctr.low = st->thread_queue_len & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_threadsQueueLength\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS
static int
handle_bansTotal(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans >> 32;
            ctr.low = st->bans & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansTotal\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_COMPLETED
static int
handle_bansCompleted(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_completed >> 32;
            ctr.low = st->bans_completed & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansCompleted\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_OBJ
static int
handle_bansObj(netsnmp_mib_handler *handler,
               netsnmp_handler_registration *reginfo,
               netsnmp_agent_request_info *reqinfo,
               netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_obj >> 32;
            ctr.low = st->bans_obj & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansObj\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_REQ
static int
handle_bansReq(netsnmp_mib_handler *handler,
               netsnmp_handler_registration *reginfo,
               netsnmp_agent_request_info *reqinfo,
               netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_req >> 32;
            ctr.low = st->bans_req & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansReq\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_ADDED
static int
handle_bansAdded(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_added >> 32;
            ctr.low = st->bans_added & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansAdded\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_DELETED
static int
handle_bansDeleted(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_deleted >> 32;
            ctr.low = st->bans_deleted & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansDeleted\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_TESTED
static int
handle_bansTested(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_tested >> 32;
            ctr.low = st->bans_tested & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansTested\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_OBJ_KILLED
static int
handle_bansObjectsKilled(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_obj_killed >> 32;
            ctr.low = st->bans_obj_killed & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansObjectsKilled\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_TESTED
static int
handle_bansLurkerTested(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_lurker_tested >> 32;
            ctr.low = st->bans_lurker_tested & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansLurkerTested\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_TESTS_TESTED
static int
handle_bansTestTested(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_tests_tested >> 32;
            ctr.low = st->bans_tests_tested & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansTestTested\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_TESTS_TESTED
static int
handle_bansLurkerTestTested(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_lurker_tests_tested >> 32;
            ctr.low = st->bans_lurker_tests_tested & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansLurkerTestTested\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_OBJ_KILLED
static int
handle_bansLurkerObjKilled(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_lurker_obj_killed >> 32;
            ctr.low = st->bans_lurker_obj_killed & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansLurkerObjKilled\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_DUPS
static int
handle_bansDups(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_dups >> 32;
            ctr.low = st->bans_dups & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansDups\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_CONTENTION
static int
handle_bansLurkerContention(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_lurker_contention >> 32;
            ctr.low = st->bans_lurker_contention & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansLurkerContention\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_PERSISTED_BYTES
static int
handle_bansPersistedBytes(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_persisted_bytes >> 32;
            ctr.low = st->bans_persisted_bytes & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansPersistedBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_PERSISTED_FRAGMENTATION
static int
handle_bansPersistedFragmentation(netsnmp_mib_handler *handler,
                                  netsnmp_handler_registration *reginfo,
                                  netsnmp_agent_request_info *reqinfo,
                                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->bans_persisted_fragmentation >> 32;
            ctr.low = st->bans_persisted_fragmentation & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansPersistedFragmentation\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJECT
static int
handle_objectsCount(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_object >> 32;
            ctr.low = st->n_object & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsCount\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VAMPIREOBJECT
static int
handle_objectsVampire(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_vampireobject >> 32;
            ctr.low = st->n_vampireobject & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsVampire\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJECTCORE
static int
handle_objectsCore(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_objectcore >> 32;
            ctr.low = st->n_objectcore & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsCore\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJECTHEAD
static int
handle_objectsHead(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_objecthead >> 32;
            ctr.low = st->n_objecthead & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsHead\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_EXPIRED
static int
handle_objectsExpired(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_expired >> 32;
            ctr.low = st->n_expired & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsExpired\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_LRU_NUKED
static int
handle_objectsLRUNuked(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_lru_nuked >> 32;
            ctr.low = st->n_lru_nuked & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsLRUNuked\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_LRU_MOVED
static int
handle_objectsLRUMoved(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_lru_moved >> 32;
            ctr.low = st->n_lru_moved & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsLRUMoved\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_PURGES
static int
handle_objectsPurges(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_purges >> 32;
            ctr.low = st->n_purges & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsPurges\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJ_PURGED
static int
handle_objectsObjPurged(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_obj_purged >> 32;
            ctr.low = st->n_obj_purged & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsObjPurged\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_GZIP
static int
handle_objectsGzip(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_gzip >> 32;
            ctr.low = st->n_gzip & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsGzip\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_GUNZIP
static int
handle_objectsGunzip(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_gunzip >> 32;
            ctr.low = st->n_gunzip & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsGunzip\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VCL
static int
handle_vclTotal(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_vcl >> 32;
            ctr.low = st->n_vcl & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_vclTotal\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VCL_AVAIL
static int
handle_vclAvail(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_vcl_avail >> 32;
            ctr.low = st->n_vcl_avail & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_vclAvail\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VCL_DISCARD
static int
handle_vclDiscard(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            struct VSC_C_main const *st = VSC_Main(vd, NULL);
            struct counter64 ctr;
            if (!st)
                return SNMP_ERR_NOSUCHNAME;
            ctr.high = st->n_vcl_discard >> 32;
            ctr.low = st->n_vcl_discard & 0xffffffff;
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
                                     &ctr, sizeof(ctr));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_vclDiscard\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
#endif



/** handles requests for the backendTable table */
static int
handle_table_backendTable(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{
    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct backendTable_entry *table_entry;

    switch (reqinfo->mode) {
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct backendTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_VBEIDENT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->vbeIdent,
                                         table_entry->vbeIdent_len);
                break;
            case COLUMN_VBEIPV4:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->vbeIPv4,
                                         table_entry->vbeIPv4_len);
                break;
            case COLUMN_VBEIPV6:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->vbeIPv6,
                                         table_entry->vbeIPv6_len);
                break;
            case COLUMN_VBEPORT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb,
                                           ASN_UNSIGNED,
                                           table_entry->vbePort);
                break;
            case COLUMN_VBEHAPPYPROBES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbeHappyProbes,
                                         sizeof(table_entry->
                                                vbeHappyProbes));
                break;
            case COLUMN_VBEVCLS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbeVcls,
                                         sizeof(table_entry->vbeVcls));
                break;
            case COLUMN_VBEREQUESTHEADERBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->
                                         vbeRequestHeaderBytes,
                                         sizeof(table_entry->
                                                vbeRequestHeaderBytes));
                break;
            case COLUMN_VBEREQUESTBODYBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbeRequestBodyBytes,
                                         sizeof(table_entry->
                                                vbeRequestBodyBytes));
                break;
            case COLUMN_VBERESPONSEHEADERBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->
                                         vbeResponseHeaderBytes,
                                         sizeof(table_entry->
                                                vbeResponseHeaderBytes));
                break;
            case COLUMN_VBERESPONSEBODYBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->
                                         vbeResponseBodyBytes,
                                         sizeof(table_entry->
                                                vbeResponseBodyBytes));
                break;
            case COLUMN_VBEPIPEHEADERBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbePipeHeaderBytes,
                                         sizeof(table_entry->
                                                vbePipeHeaderBytes));
                break;
            case COLUMN_VBEPIPEIN:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbePipeIn,
                                         sizeof(table_entry->vbePipeIn));
                break;
            case COLUMN_VBEPIPEOUT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbePipeOut,
                                         sizeof(table_entry->vbePipeOut));
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;
    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_table_backendTable\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;

    }
    return SNMP_ERR_NOERROR;
}

/** Initialize the backendTable table by defining its contents and how it's structured */
static void
initialize_table_backendTable(void)
{
    const oid       backendTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 3 };
    const size_t    backendTable_oid_len = OID_LENGTH(backendTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_tdata  *table_data;
    netsnmp_table_registration_info *table_info;
    netsnmp_cache  *cache;

    DEBUGMSGTL(("varnish_mib", "initializing table backendTable\n"));

    reg =
        netsnmp_create_handler_registration("backendTable",
                                            handle_table_backendTable,
                                            backendTable_oid,
                                            backendTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_data = netsnmp_tdata_create_table("backendTable", 0);
    if (!table_data) {
        snmp_log(LOG_ERR, "error creating tdata table for backendTable\n");
        return;
    }
    cache = netsnmp_cache_create(backendTable_timeout,
                                 backendTable_load, backendTable_free,
                                 backendTable_oid, backendTable_oid_len);
    if (!cache) {
        snmp_log(LOG_ERR, "error creating cache for backendTable\n");
    } else
        cache->magic = (void *) table_data;
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (!table_info) {
        snmp_log(LOG_ERR, "error creating table info for backendTable\n");
        return;
    }
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: vbeIndex */
                                     0);

    table_info->min_column = COLUMN_VBEIDENT;
    table_info->max_column = COLUMN_VBEPIPEOUT;

    netsnmp_tdata_register(reg, table_data, table_info);
    if (cache)
        netsnmp_inject_handler(reg, netsnmp_cache_handler_get(cache));
    /*
     * netsnmp_inject_handler_before(reg, netsnmp_cache_handler_get(cache),
     * TABLE_TDATA_NAME);
     */
}



/** handles requests for the banTable table */
static int
handle_table_banTable(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{
    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct banTable_entry *table_entry;

    switch (reqinfo->mode) {
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct banTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_BANTIME:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->banTime,
                                         table_entry->banTime_len);
                break;
            case COLUMN_BANREFCOUNT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->banRefCount);
                break;
            case COLUMN_BANEXPRESSION:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->banExpression,
                                         table_entry->banExpression_len);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;
    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_table_banTable\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;

    }
    return SNMP_ERR_NOERROR;
}

/** Initialize the banTable table by defining its contents and how it's structured */
static void
initialize_table_banTable(void)
{
    const oid       banTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 18 };
    const size_t    banTable_oid_len = OID_LENGTH(banTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_tdata  *table_data;
    netsnmp_table_registration_info *table_info;
    netsnmp_cache  *cache;

    DEBUGMSGTL(("varnish_mib", "initializing table banTable\n"));

    reg =
        netsnmp_create_handler_registration("banTable",
                                            handle_table_banTable,
                                            banTable_oid, banTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_data = netsnmp_tdata_create_table("banTable", 0);
    if (!table_data) {
        snmp_log(LOG_ERR, "error creating tdata table for banTable\n");
        return;
    }
    cache = netsnmp_cache_create(banTable_timeout,
                                 banTable_load, banTable_free,
                                 banTable_oid, banTable_oid_len);
    if (!cache) {
        snmp_log(LOG_ERR, "error creating cache for banTable\n");
    } else
        cache->magic = (void *) table_data;
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (!table_info) {
        snmp_log(LOG_ERR, "error creating table info for banTable\n");
        return;
    }
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: banIndex */
                                     0);

    table_info->min_column = COLUMN_BANTIME;
    table_info->max_column = COLUMN_BANEXPRESSION;

    netsnmp_tdata_register(reg, table_data, table_info);
    if (cache)
        netsnmp_inject_handler(reg, netsnmp_cache_handler_get(cache));
    /*
     * netsnmp_inject_handler_before(reg, netsnmp_cache_handler_get(cache),
     * TABLE_TDATA_NAME);
     */
}


/** Initializes the varnish_mib.c module */
void
init_varnish_mib(void)
{
#if HAVE_STRUCT_VSC_C_MAIN_SESS_CONN
    const oid       clientAcceptedConnections_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 1 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ
    const oid       clientRequestsReceived_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 2 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CACHE_HIT
    const oid       clientCacheHits_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 3 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CACHE_HITPASS
    const oid       clientCacheHitsPass_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 4 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CACHE_MISS
    const oid       clientCacheMisses_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 5 };
#endif

    const oid       clientBan_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 6 };

#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_400
    const oid       clientRequests400_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 7 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_411
    const oid       clientRequests411_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 8 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_413
    const oid       clientRequests413_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 9 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_417
    const oid       clientRequests417_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 10 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_CONN
    const oid       backendConnSuccess_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 1 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_UNHEALTHY
    const oid       backendConnNotAttempted_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 2 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_BUSY
    const oid       backendConnToMany_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 3 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_FAIL
    const oid       backendConnFailures_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 4 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_REUSE
    const oid       backendConnReuses_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 5 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_RECYCLE
    const oid       backendConnRecycled_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 6 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_TOOLATE
    const oid       backendConnUnused_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 7 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_RETRY
    const oid       backendConnRetry_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 8 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_REQ
    const oid       backendRequests_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 2 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_SESS
    const oid       totalSessions_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 1 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_REQ
    const oid       totalRequests_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 2 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE
    const oid       totalPipe_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 3 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PASS
    const oid       totalPass_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 4 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_FETCH
    const oid       totalFetch_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 5 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_REQ_HDRBYTES
    const oid       totalRequestHeaderBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 6 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_REQ_BODYBYTES
    const oid       totalRequestBodyBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 7 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_RESP_HDRBYTES
    const oid       totalResponseHeaderBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 8 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_RESP_BODYBYTES
    const oid       totalResponseBodyBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 9 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE_HDRBYTES
    const oid       totalPipeHeaderBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 10 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE_IN
    const oid       totalPipeIn_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 11 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE_OUT
    const oid       totalPipeOut_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 12 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_UPTIME
    const oid       uptime_oid[] = { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 4, 1 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_CONN
    const oid       sessAccepted_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 1 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_QUEUED
    const oid       sessQueued_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 2 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_DROPPED
    const oid       sessDropped_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 3 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_CLOSED
    const oid       sessClosed_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 4 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_PIPELINE
    const oid       sessPipeline_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 5 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_READAHEAD
    const oid       sessReadAhead_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 6 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_HERD
    const oid       sessHerd_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 7 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_DROP
    const oid       sessDrop_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 8 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_FAIL
    const oid       sessFail_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 9 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_PIPE_OVERFLOW
    const oid       sessPipeOverflow_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 10 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_POOLS
    const oid       threadsPools_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 1 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS
    const oid       threadsTotal_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 2 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_LIMITED
    const oid       threadsLimitHits_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 3 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_CREATED
    const oid       threadsCreated_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 4 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_DESTROYED
    const oid       threadsDestroyed_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 5 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_FAILED
    const oid       threadsFailed_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 6 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREAD_QUEUE_LEN
    const oid       threadsQueueLength_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 7 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS
    const oid       bansTotal_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 1 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_COMPLETED
    const oid       bansCompleted_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 2 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_OBJ
    const oid       bansObj_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 3 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_REQ
    const oid       bansReq_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 4 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_ADDED
    const oid       bansAdded_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 5 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_DELETED
    const oid       bansDeleted_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 6 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_TESTED
    const oid       bansTested_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 7 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_OBJ_KILLED
    const oid       bansObjectsKilled_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 8 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_TESTED
    const oid       bansLurkerTested_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 9 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_TESTS_TESTED
    const oid       bansTestTested_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 10 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_TESTS_TESTED
    const oid       bansLurkerTestTested_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 11 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_OBJ_KILLED
    const oid       bansLurkerObjKilled_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 12 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_DUPS
    const oid       bansDups_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 13 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_CONTENTION
    const oid       bansLurkerContention_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 14 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_PERSISTED_BYTES
    const oid       bansPersistedBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 15 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_PERSISTED_FRAGMENTATION
    const oid       bansPersistedFragmentation_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 17 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJECT
    const oid       objectsCount_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 1 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VAMPIREOBJECT
    const oid       objectsVampire_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 2 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJECTCORE
    const oid       objectsCore_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 3 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJECTHEAD
    const oid       objectsHead_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 4 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_EXPIRED
    const oid       objectsExpired_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 5 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_LRU_NUKED
    const oid       objectsLRUNuked_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 6 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_LRU_MOVED
    const oid       objectsLRUMoved_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 7 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_PURGES
    const oid       objectsPurges_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 8 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJ_PURGED
    const oid       objectsObjPurged_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 9 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_GZIP
    const oid       objectsGzip_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 10 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_GUNZIP
    const oid       objectsGunzip_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 11 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VCL
    const oid       vclTotal_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 10, 1 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VCL_AVAIL
    const oid       vclAvail_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 10, 2 };
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VCL_DISCARD
    const oid       vclDiscard_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 10, 3 };
#endif

    DEBUGMSGTL(("varnish_mib", "Initializing\n"));

    if (!register_config_handler("snmpd", "varnishBanTableTimeout",
                                 varnish_ban_table_timeout_parser,
                                 NULL, "varnishBanTableTimeout SECONDS"))
        snmp_log(LOG_ERR, "can't register config handler\n");

    if (!register_config_handler("snmpd", "varnishBackendTableTimeout",
                                 varnish_backend_table_timeout_parser,
                                 NULL,
                                 "varnishBackendTableTimeout SECONDS"))
        snmp_log(LOG_ERR, "can't register config handler\n");

    if (!register_config_handler("snmpd", "varnishCLIPortTimeout",
                                 varnish_vcli_timeout_parser,
                                 NULL, "varnishCLIPortTimeout SECONDS"))
        snmp_log(LOG_ERR, "can't register config handler\n");

#if HAVE_STRUCT_VSC_C_MAIN_SESS_CONN
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientAcceptedConnections",
                             handle_clientAcceptedConnections,
                             clientAcceptedConnections_oid,
                             OID_LENGTH(clientAcceptedConnections_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientRequestsReceived",
                             handle_clientRequestsReceived,
                             clientRequestsReceived_oid,
                             OID_LENGTH(clientRequestsReceived_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CACHE_HIT
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientCacheHits", handle_clientCacheHits,
                             clientCacheHits_oid,
                             OID_LENGTH(clientCacheHits_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CACHE_HITPASS
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientCacheHitsPass",
                             handle_clientCacheHitsPass,
                             clientCacheHitsPass_oid,
                             OID_LENGTH(clientCacheHitsPass_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CACHE_MISS
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientCacheMisses", handle_clientCacheMisses,
                             clientCacheMisses_oid,
                             OID_LENGTH(clientCacheMisses_oid),
                             HANDLER_CAN_RONLY));
#endif

    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientBan", handle_clientBan, clientBan_oid,
                             OID_LENGTH(clientBan_oid),
                             HANDLER_CAN_RWRITE));

#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_400
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientRequests400", handle_clientRequests400,
                             clientRequests400_oid,
                             OID_LENGTH(clientRequests400_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_411
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientRequests411", handle_clientRequests411,
                             clientRequests411_oid,
                             OID_LENGTH(clientRequests411_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_413
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientRequests413", handle_clientRequests413,
                             clientRequests413_oid,
                             OID_LENGTH(clientRequests413_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_CLIENT_REQ_417
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientRequests417", handle_clientRequests417,
                             clientRequests417_oid,
                             OID_LENGTH(clientRequests417_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_CONN
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnSuccess",
                             handle_backendConnSuccess,
                             backendConnSuccess_oid,
                             OID_LENGTH(backendConnSuccess_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_UNHEALTHY
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnNotAttempted",
                             handle_backendConnNotAttempted,
                             backendConnNotAttempted_oid,
                             OID_LENGTH(backendConnNotAttempted_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_BUSY
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnToMany", handle_backendConnToMany,
                             backendConnToMany_oid,
                             OID_LENGTH(backendConnToMany_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_FAIL
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnFailures",
                             handle_backendConnFailures,
                             backendConnFailures_oid,
                             OID_LENGTH(backendConnFailures_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_REUSE
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnReuses", handle_backendConnReuses,
                             backendConnReuses_oid,
                             OID_LENGTH(backendConnReuses_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_RECYCLE
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnRecycled",
                             handle_backendConnRecycled,
                             backendConnRecycled_oid,
                             OID_LENGTH(backendConnRecycled_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_TOOLATE
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnUnused", handle_backendConnUnused,
                             backendConnUnused_oid,
                             OID_LENGTH(backendConnUnused_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_RETRY
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnRetry", handle_backendConnRetry,
                             backendConnRetry_oid,
                             OID_LENGTH(backendConnRetry_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BACKEND_REQ
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendRequests", handle_backendRequests,
                             backendRequests_oid,
                             OID_LENGTH(backendRequests_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_SESS
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalSessions", handle_totalSessions,
                             totalSessions_oid,
                             OID_LENGTH(totalSessions_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_REQ
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalRequests", handle_totalRequests,
                             totalRequests_oid,
                             OID_LENGTH(totalRequests_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPipe", handle_totalPipe, totalPipe_oid,
                             OID_LENGTH(totalPipe_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PASS
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPass", handle_totalPass, totalPass_oid,
                             OID_LENGTH(totalPass_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_FETCH
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalFetch", handle_totalFetch,
                             totalFetch_oid, OID_LENGTH(totalFetch_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_REQ_HDRBYTES
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalRequestHeaderBytes",
                             handle_totalRequestHeaderBytes,
                             totalRequestHeaderBytes_oid,
                             OID_LENGTH(totalRequestHeaderBytes_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_REQ_BODYBYTES
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalRequestBodyBytes",
                             handle_totalRequestBodyBytes,
                             totalRequestBodyBytes_oid,
                             OID_LENGTH(totalRequestBodyBytes_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_RESP_HDRBYTES
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalResponseHeaderBytes",
                             handle_totalResponseHeaderBytes,
                             totalResponseHeaderBytes_oid,
                             OID_LENGTH(totalResponseHeaderBytes_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_RESP_BODYBYTES
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalResponseBodyBytes",
                             handle_totalResponseBodyBytes,
                             totalResponseBodyBytes_oid,
                             OID_LENGTH(totalResponseBodyBytes_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE_HDRBYTES
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPipeHeaderBytes",
                             handle_totalPipeHeaderBytes,
                             totalPipeHeaderBytes_oid,
                             OID_LENGTH(totalPipeHeaderBytes_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE_IN
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPipeIn", handle_totalPipeIn,
                             totalPipeIn_oid, OID_LENGTH(totalPipeIn_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_S_PIPE_OUT
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPipeOut", handle_totalPipeOut,
                             totalPipeOut_oid,
                             OID_LENGTH(totalPipeOut_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_UPTIME
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("uptime", handle_uptime, uptime_oid,
                             OID_LENGTH(uptime_oid), HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_CONN
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessAccepted", handle_sessAccepted,
                             sessAccepted_oid,
                             OID_LENGTH(sessAccepted_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_QUEUED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessQueued", handle_sessQueued,
                             sessQueued_oid, OID_LENGTH(sessQueued_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_DROPPED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessDropped", handle_sessDropped,
                             sessDropped_oid, OID_LENGTH(sessDropped_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_CLOSED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessClosed", handle_sessClosed,
                             sessClosed_oid, OID_LENGTH(sessClosed_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_PIPELINE
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessPipeline", handle_sessPipeline,
                             sessPipeline_oid,
                             OID_LENGTH(sessPipeline_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_READAHEAD
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessReadAhead", handle_sessReadAhead,
                             sessReadAhead_oid,
                             OID_LENGTH(sessReadAhead_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_HERD
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessHerd", handle_sessHerd, sessHerd_oid,
                             OID_LENGTH(sessHerd_oid), HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_DROP
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessDrop", handle_sessDrop, sessDrop_oid,
                             OID_LENGTH(sessDrop_oid), HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_FAIL
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessFail", handle_sessFail, sessFail_oid,
                             OID_LENGTH(sessFail_oid), HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_SESS_PIPE_OVERFLOW
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessPipeOverflow", handle_sessPipeOverflow,
                             sessPipeOverflow_oid,
                             OID_LENGTH(sessPipeOverflow_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_POOLS
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsPools", handle_threadsPools,
                             threadsPools_oid,
                             OID_LENGTH(threadsPools_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsTotal", handle_threadsTotal,
                             threadsTotal_oid,
                             OID_LENGTH(threadsTotal_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_LIMITED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsLimitHits", handle_threadsLimitHits,
                             threadsLimitHits_oid,
                             OID_LENGTH(threadsLimitHits_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_CREATED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsCreated", handle_threadsCreated,
                             threadsCreated_oid,
                             OID_LENGTH(threadsCreated_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_DESTROYED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsDestroyed", handle_threadsDestroyed,
                             threadsDestroyed_oid,
                             OID_LENGTH(threadsDestroyed_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREADS_FAILED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsFailed", handle_threadsFailed,
                             threadsFailed_oid,
                             OID_LENGTH(threadsFailed_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_THREAD_QUEUE_LEN
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsQueueLength",
                             handle_threadsQueueLength,
                             threadsQueueLength_oid,
                             OID_LENGTH(threadsQueueLength_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansTotal", handle_bansTotal, bansTotal_oid,
                             OID_LENGTH(bansTotal_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_COMPLETED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansCompleted", handle_bansCompleted,
                             bansCompleted_oid,
                             OID_LENGTH(bansCompleted_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_OBJ
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansObj", handle_bansObj, bansObj_oid,
                             OID_LENGTH(bansObj_oid), HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_REQ
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansReq", handle_bansReq, bansReq_oid,
                             OID_LENGTH(bansReq_oid), HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_ADDED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansAdded", handle_bansAdded, bansAdded_oid,
                             OID_LENGTH(bansAdded_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_DELETED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansDeleted", handle_bansDeleted,
                             bansDeleted_oid, OID_LENGTH(bansDeleted_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_TESTED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansTested", handle_bansTested,
                             bansTested_oid, OID_LENGTH(bansTested_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_OBJ_KILLED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansObjectsKilled", handle_bansObjectsKilled,
                             bansObjectsKilled_oid,
                             OID_LENGTH(bansObjectsKilled_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_TESTED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansLurkerTested", handle_bansLurkerTested,
                             bansLurkerTested_oid,
                             OID_LENGTH(bansLurkerTested_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_TESTS_TESTED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansTestTested", handle_bansTestTested,
                             bansTestTested_oid,
                             OID_LENGTH(bansTestTested_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_TESTS_TESTED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansLurkerTestTested",
                             handle_bansLurkerTestTested,
                             bansLurkerTestTested_oid,
                             OID_LENGTH(bansLurkerTestTested_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_OBJ_KILLED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansLurkerObjKilled",
                             handle_bansLurkerObjKilled,
                             bansLurkerObjKilled_oid,
                             OID_LENGTH(bansLurkerObjKilled_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_DUPS
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansDups", handle_bansDups, bansDups_oid,
                             OID_LENGTH(bansDups_oid), HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_LURKER_CONTENTION
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansLurkerContention",
                             handle_bansLurkerContention,
                             bansLurkerContention_oid,
                             OID_LENGTH(bansLurkerContention_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_PERSISTED_BYTES
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansPersistedBytes",
                             handle_bansPersistedBytes,
                             bansPersistedBytes_oid,
                             OID_LENGTH(bansPersistedBytes_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_BANS_PERSISTED_FRAGMENTATION
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansPersistedFragmentation",
                             handle_bansPersistedFragmentation,
                             bansPersistedFragmentation_oid,
                             OID_LENGTH(bansPersistedFragmentation_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJECT
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsCount", handle_objectsCount,
                             objectsCount_oid,
                             OID_LENGTH(objectsCount_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VAMPIREOBJECT
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsVampire", handle_objectsVampire,
                             objectsVampire_oid,
                             OID_LENGTH(objectsVampire_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJECTCORE
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsCore", handle_objectsCore,
                             objectsCore_oid, OID_LENGTH(objectsCore_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJECTHEAD
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsHead", handle_objectsHead,
                             objectsHead_oid, OID_LENGTH(objectsHead_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_EXPIRED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsExpired", handle_objectsExpired,
                             objectsExpired_oid,
                             OID_LENGTH(objectsExpired_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_LRU_NUKED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsLRUNuked", handle_objectsLRUNuked,
                             objectsLRUNuked_oid,
                             OID_LENGTH(objectsLRUNuked_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_LRU_MOVED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsLRUMoved", handle_objectsLRUMoved,
                             objectsLRUMoved_oid,
                             OID_LENGTH(objectsLRUMoved_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_PURGES
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsPurges", handle_objectsPurges,
                             objectsPurges_oid,
                             OID_LENGTH(objectsPurges_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_OBJ_PURGED
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsObjPurged", handle_objectsObjPurged,
                             objectsObjPurged_oid,
                             OID_LENGTH(objectsObjPurged_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_GZIP
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsGzip", handle_objectsGzip,
                             objectsGzip_oid, OID_LENGTH(objectsGzip_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_GUNZIP
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsGunzip", handle_objectsGunzip,
                             objectsGunzip_oid,
                             OID_LENGTH(objectsGunzip_oid),
                             HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VCL
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("vclTotal", handle_vclTotal, vclTotal_oid,
                             OID_LENGTH(vclTotal_oid), HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VCL_AVAIL
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("vclAvail", handle_vclAvail, vclAvail_oid,
                             OID_LENGTH(vclAvail_oid), HANDLER_CAN_RONLY));
#endif
#if HAVE_STRUCT_VSC_C_MAIN_N_VCL_DISCARD
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("vclDiscard", handle_vclDiscard,
                             vclDiscard_oid, OID_LENGTH(vclDiscard_oid),
                             HANDLER_CAN_RONLY));
#endif
    initialize_table_backendTable();
    initialize_table_banTable();
    varnish_snmp_init();
}

void
deinit_varnish_mib(void)
{
    varnish_snmp_deinit();
}

/*
 * Local variables:
 * buffer-read-only: t
 * End:
 * vi: set ro:
 */
